////////////////////////////////////////////////////////////////////////////////
//:  Ը 
//e-mail: urvanovf@hotmail.ru
//: http://www.dxgames.narod.ru
////////////////////////////////////////////////////////////////////////////////

#include "cglstdafx.h"
#include "cgl.h"


using namespace std;

int CGL::n;
GLfloat CGL::m_fLetterSize;
GLfloat CGL::m_fAspectRatio;
GLsizei CGL::m_siWidth,
		CGL::m_siHeight;
GLfloat CGL::m_fControlsDepth=0.1f;

GLboolean CGL::m_bAllControlsRemoved=false;

GLfloat ** CGL::m_pLetters;

CONTROLS_LIST CGL::m_lstControls;
CONTROLS_LIST::iterator * CGL::m_iSelectedControl;
PFNTIMERPROC * CGL::m_pfnOnTimer=NULL;
PFNRENDERPROC * CGL::m_pfnOnRender=NULL;
PFNSPECIALKEYPROC * CGL::m_pfnOnSpecialKey=NULL;
PFNMOUSEPROC * CGL::m_pfnOnMouse=NULL;
PFNKEYBOARDPROC* CGL::m_pfnOnKeyboard=NULL;
PFNRESIZEPROC* CGL::m_pfnOnResize=NULL;
GLint   CGL::m_nTimerDelay=50;
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CGL::CGL(char * WindowTitle)
{
	glutInitDisplayMode(GLUT_MULTISAMPLE| GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH |GLUT_STENCIL);
	glEnable(GLUT_MULTISAMPLE);
	glutCreateWindow(WindowTitle);
	glutDisplayFunc(Render);
	glutReshapeFunc(OnResize);
	glutSpecialFunc(OnSpecialKey);
	glutKeyboardFunc(OnKeyboard);
	glutTimerFunc(m_nTimerDelay,OnTimer,0);
	glutMouseFunc(OnMouse);
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_LIGHTING);
	glEnableClientState(GL_COLOR_ARRAY);
	glEnableClientState(GL_VERTEX_ARRAY);
	glEnableClientState(GL_NORMAL_ARRAY);
	glEnable(GL_CULL_FACE);
	glEnable(GL_COLOR_MATERIAL);
	//glPolygonMode(GL_FRONT,GL_LINE);
	InitFont();



	}

CGL::~CGL()
{

}




void CGL::Render()
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT |GL_STENCIL_BUFFER_BIT);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	if (m_pfnOnRender) m_pfnOnRender();

	glPushAttrib(GL_ENABLE_BIT|GL_COLOR_BUFFER_BIT);
	glDisable(GL_LIGHTING);
	glDisable(GL_DEPTH_TEST);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();



	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
	GLfloat fLastColor[4];
	glGetFloatv(GL_CURRENT_COLOR,fLastColor);

	CONTROLS_LIST::iterator iList;
	for (iList=m_lstControls.begin();iList!=m_lstControls.end();iList++)
	{

		if ((CGLControl::GetSelected()) ==(*iList))
			glColor4f(1.0,1.0,0.0,0.5);
		else
			glColor4f(0.0,1.0,0.0,0.5);
		(*iList)->Draw();
	}

	glPopAttrib();

	glColor4fv(fLastColor);
	//glFlush();
	glutSwapBuffers();
}

void CGL::OnTimer(GLint value)
{
	if (m_pfnOnTimer) m_pfnOnTimer(value);
	glutPostRedisplay();
	glutTimerFunc(m_nTimerDelay, OnTimer, 1);

}

void CGL::OnResize(GLsizei w, GLsizei h)
{
	if (h == 0)
		h = 1;
    if (w == 0)
        w=1;
	glViewport(0, 0, w, h);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	m_fAspectRatio = (GLfloat)w / (GLfloat)h;

	m_siWidth=w;
	m_siHeight=h;


	GLfloat zn=1.0f,zf=FLT_MAX;
	GLfloat l=-1.0f,
		r=1.0f,
		b=-1.0f,
		t=1.0f;

	if (w>=h)
	{
		r=r*m_fAspectRatio;
		l=-r;
	}
	else
	{
		t=t/m_fAspectRatio;
		b=-t;
	}

	GLfloat mat[]={
		2*zn/(r-l)   ,0            ,(l+r)/(r-l)     ,0,
		0            ,2*zn/(t-b)   ,(t+b)/(t-b)     ,0,
		0			 , 0			 ,zn*zf/(zn-zf)    ,zn*zf/(zn-zf),
		0            ,0            ,  -1				 ,0,


	};

	glLoadMatrixf(mat);

	glMatrixMode(GL_MODELVIEW);
	//glLoadIdentity();

	//   
	if (m_siWidth>m_siHeight) m_fLetterSize=2.0/(GLfloat)m_siHeight;
	else m_fLetterSize=2.0/(GLfloat)m_siWidth;
	m_fLetterSize*=8.0;
	if (m_pfnOnResize) m_pfnOnResize(w,h);
}


void CGL::SetPointLight(GLint p_nIndex,const CGLVector3& p_fPosition,const CGLColor& p_fColor)
{
	GLfloat afPosition[]={p_fPosition.x,p_fPosition.y,p_fPosition.z,0.0f};
	GLfloat afColor[]={p_fColor.r,p_fColor.g,p_fColor.b,p_fColor.a};
	glLightfv(p_nIndex,GL_DIFFUSE,afColor);
	glLightfv(p_nIndex,GL_SPECULAR,afColor);
	glLightfv(p_nIndex,GL_POSITION,afPosition);
	glLightf(p_nIndex,GL_SPOT_CUTOFF,180.0f);
	glEnable(p_nIndex);
}

void CGL::SetSpotLight(GLint p_nIndex,const CGLVector3& p_fPosition,const CGLVector3& p_fDirection,
					   const CGLColor& p_fColor)
{
	GLfloat afPosition[]={p_fPosition.x,p_fPosition.y,p_fPosition.z,1.0f},
		afDirection[]={p_fDirection.x,p_fDirection.y,p_fDirection.z},
		afColor[]={p_fColor.r,p_fColor.g,p_fColor.b,p_fColor.a};

	glLightfv(p_nIndex,GL_DIFFUSE,afColor);
	glLightfv(p_nIndex,GL_SPECULAR,afColor);
	glLightfv(p_nIndex,GL_POSITION,afPosition);
	glLightfv(p_nIndex,GL_SPOT_DIRECTION,afDirection);

	glLightf(p_nIndex,GL_SPOT_CUTOFF,60.0f);
	glLightf(p_nIndex,GL_SPOT_EXPONENT,10.0f);
		glEnable(p_nIndex);
}

void CGL::OnSpecialKey(GLint p_nKey,GLint p_nx,GLint p_ny)
{

	if (!m_lstControls.empty())(*(*m_iSelectedControl))->OnSpecialKey(p_nKey,p_nx,p_ny);
	if (m_pfnOnSpecialKey) m_pfnOnSpecialKey(p_nKey,p_nx,p_ny);
}

void CGL::OnKeyboard(unsigned char p_chKey,GLint p_nx,GLint p_ny)
{
	char chKey=(char)p_chKey;
	switch (chKey)
	{

	case '	'://
		if (!m_lstControls.empty())
		{
			(*m_iSelectedControl)++;
			if ((*m_iSelectedControl)==m_lstControls.end())
				(*m_iSelectedControl)=m_lstControls.begin();
			(**m_iSelectedControl)->SetSelected();
		}
		break;
	default:
		if (!m_lstControls.empty())
		{
			(**m_iSelectedControl)->OnKeyboard(chKey,p_nx,p_ny);

		}
		if (m_bAllControlsRemoved) m_bAllControlsRemoved=false;
		if (m_pfnOnKeyboard) m_pfnOnKeyboard((char )p_chKey,p_nx,p_ny);
		break;
	}
}
void CGL::SetMaterial(const CGLColor & p_Color,GLfloat p_fPower)
{
	glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,(float *)&p_Color);
}


GLboolean CGL::AddControl(const CGLControl* p_pControl)
{
	m_lstControls.push_back((CGLControl*)p_pControl);
	if (m_iSelectedControl != NULL)
	{
		delete m_iSelectedControl;
	}
	m_iSelectedControl = new CONTROLS_LIST::iterator();
	(*m_iSelectedControl)=m_lstControls.begin();
	return 1;
}

void CGL::RemoveAllControls(void)
{
	CONTROLS_LIST::iterator iList;
	for (iList=m_lstControls.begin();iList!=m_lstControls.end();iList++)
	{
		delete (*iList);
	}
	m_lstControls.clear();
	m_bAllControlsRemoved=true;
	delete m_iSelectedControl;
	m_iSelectedControl=NULL;
}

void CGL::OnMouse(GLint p_nButton,GLint p_nState,GLint p_nx,GLint p_ny)
{
	GLfloat fx,fy;
	WindowPosToGLPos(p_nx,p_ny,&fx,&fy);
	CONTROLS_LIST::iterator iList;
	CGLControl* p;
	for (iList=m_lstControls.begin();iList!=m_lstControls.end();iList++)
	{
		p=(*iList);
		if (cpputils::IsPointInBox(fx,fy,p->GetSystemX(), p->GetSystemY(),p->GetSystemWidth(), p->GetSystemHeight()))
            p->OnMouse(p_nButton,p_nState,fx,fy);
		if (m_bAllControlsRemoved) { m_bAllControlsRemoved=false;break;}
	}
}

void CGL::OnMouseMove(int p_nx, int p_ny)
{
    GLfloat fMouseX,fMouseY;
	WindowPosToGLPos(p_nx,p_ny,&fMouseX,&fMouseY);
    CONTROLS_LIST::iterator iList;
    CGLControl* p;
    for (iList=m_lstControls.begin();iList!=m_lstControls.end();iList++)
    {
        p=(*iList);
        GLfloat x,y,w,h;
        x=p->GetSystemX();
        y=p->GetSystemY();
        w=p->GetSystemWidth();
        h=p->GetSystemHeight();
        if (cpputils::IsPointInBox(fMouseX,fMouseY,x,y,w,h))
        {
            p->SetSelected();
        }
    }
}

void CGL::DrawText(GLfloat p_nx,GLfloat p_ny, GLfloat p_nWidth, GLfloat p_nHeight,const char * str,GLint p_nStringLength)
{
	glPushAttrib(GL_ENABLE_BIT);
	glDisable(GL_DEPTH_TEST);
	GLint n=0,
		nFirst=0,nEnd=0;//   

	GLfloat fx=0.0,fy=0.0;

	n=0;fy=-m_fLetterSize;
	puts(str);

	while (str[n])
	{

		nEnd=nFirst+int((p_nWidth)/m_fLetterSize);
		if (nEnd<p_nStringLength)
		{
			n=nEnd;
			while ((str[n]!=' ')&&(n>0)) n--;
			if (n>nFirst) nEnd=n;

		}
		else
		{
			nEnd=p_nStringLength;
		}
		for (n=nFirst;n<nEnd;n++)
		{
			glRasterPos3f(p_nx+fx,p_ny+fy,-1.0);//,1.0f);
			glDrawPixels(8,8,GL_GREEN,GL_FLOAT,(const GLvoid *)*(m_pLetters+str[n]));
			fx+=m_fLetterSize;
		}
		if (str[nEnd]==' ') nEnd++;
		nFirst=nEnd;
		fy-=m_fLetterSize;
		if (fabs(fy)>p_nHeight) break;
		fx=0;

	}
	glPopAttrib();
}


void CGL::InitFont(void)
{
	GLint n;
	static GLfloat * Mass[256];
	m_pLetters=Mass;
	m_pLetters+=-CHAR_MIN;
	const GLfloat fPoint=1.0f;
	const GLfloat fSpace=0.0f;
	static GLfloat abyAPixels[]={
		//A
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};

	static GLfloat abyBPixels[]={
		//B
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyCPixels[]={
		//C
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyDPixels[]={
		//D
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyEPixels[]={
		//E
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyFPixels[]={
		//F
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyGPixels[]={
		//G
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fPoint,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyHPixels[]={
		//H
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyIPixels[]={
		//I
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyJPixels[]={
		//J
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyKPixels[]={
		//K
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fPoint,fPoint,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyLPixels[]={
		//L
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyMPixels[]={
		//M
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fPoint,fPoint,fSpace,fPoint,fSpace,
		fSpace,fPoint,fPoint,fSpace,fSpace,fPoint,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyNPixels[]={
		//N
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fPoint,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fPoint,fPoint,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fPoint,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyOPixels[]={
		//O
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyPPixels[]={
		//P
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyQPixels[]={
		//Q
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fPoint,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fPoint,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyRPixels[]={
		//R
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abySPixels[]={
		//S
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyTPixels[]={
		//T
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyUPixels[]={
		//U
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyVPixels[]={
		//V
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fPoint,fSpace,fPoint,fSpace,fSpace,
		fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyWPixels[]={
		//W
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fPoint,fPoint,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyXPixels[]={
		//X
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fSpace,
		fSpace,fSpace,fSpace,fPoint,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fPoint,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyYPixels[]={
		//Y
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fPoint,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyZPixels[]={
		//Z
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,



		////////////////////////////////////////
		//  
		////////////////////////////////////////
	};
	static GLfloat abyaPixels[]={
		//a
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,

	};
	static GLfloat abybPixels[]={
		//b
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abycPixels[]={
		//c
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abydPixels[]={
		//d
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyePixels[]={
		//e
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyfPixels[]={
		//f
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fPoint,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abygPixels[]={
		//g
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyhPixels[]={
		//h
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyiPixels[]={
		//i
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyjPixels[]={
		//j
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,
	};
	static GLfloat abykPixels[]={
		//k
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abylPixels[]={
		//l
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fPoint,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abymPixels[]={
		//m
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fPoint,fSpace,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fPoint,fSpace,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fPoint,fSpace,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fPoint,fSpace,fPoint,fSpace,fSpace,
		fSpace,fPoint,fPoint,fSpace,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abynPixels[]={
		//n
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyoPixels[]={
		//o
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abypPixels[]={
		//p
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyqPixels[]={
		//q
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fPoint,fPoint,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyrPixels[]={
		//r
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abysPixels[]={
		//s
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abytPixels[]={
		//t
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyuPixels[]={
		//u
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyvPixels[]={
		//v
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fPoint,fSpace,fPoint,fSpace,fSpace,
		fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abywPixels[]={
		//w
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fPoint,fPoint,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyxPixels[]={
		//x
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fSpace,
		fSpace,fSpace,fSpace,fPoint,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyyPixels[]={
		//y
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyzPixels[]={
		//z
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};

	///////////////////////////////////////////
	//Russian
	///////////////////////////////////////////
	static GLfloat *abyRUSAPixels=abyAPixels;
	static GLfloat abyRUSBPixels[]={
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat *abyRUSVPixels=abyBPixels;
	static GLfloat abyRUSGPixels[]={
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyRUSDPixels[]={
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fSpace,
		fSpace,fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fSpace,
		fSpace,fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fSpace,
		fSpace,fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fSpace,
		fSpace,fSpace,fSpace,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};

	static GLfloat *abyRUSEPixels=abyEPixels;
	static GLfloat abyRUSYOPixels[]={
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fSpace,
	};
	static GLfloat abyRUSJPixels[]={
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fPoint,fSpace,
		fSpace,fSpace,fPoint,fSpace,fPoint,fPoint,fSpace,fSpace,
		fSpace,fSpace,fSpace,fPoint,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fPoint,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fPoint,fSpace,fPoint,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyRUSZPixels[]={
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyRUSIPixels[]={
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fPoint,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fPoint,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyRUSIYPixels[]={
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fPoint,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fPoint,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fPoint,fPoint,fSpace,fSpace,fSpace,
	};
	static GLfloat *abyRUSKPixels=abyKPixels;
	static GLfloat abyRUSLPixels[]={
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fPoint,fPoint,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat *abyRUSMPixels=abyMPixels;
	static GLfloat *abyRUSNPixels=abyHPixels;
	static GLfloat *abyRUSOPixels=abyOPixels;
	static GLfloat abyRUSPPixels[]={
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat *abyRUSRPixels=abyPPixels;
	static GLfloat *abyRUSSPixels=abyCPixels;
	static GLfloat *abyRUSTPixels=abyTPixels;
	static GLfloat abyRUSUPixels[]={
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyRUSFPixels[]={
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fPoint,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat *abyRUSHPixels=abyXPixels;
	static GLfloat abyRUSCPixels[]={
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fPoint,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyRUSCHPixels[]={
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyRUSSHPixels[]={
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};

	static GLfloat abyRUSSHJPixels[]={
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fPoint,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,
		fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyRUSTVZNPixels[]={
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fPoint,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyRUSbIPixels[]={
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fPoint,fPoint,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fPoint,fSpace,
		fSpace,fPoint,fPoint,fPoint,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyRUSMZNPixels[]={
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyRUSE2Pixels[]={
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyRUSYUPixels[]={
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fPoint,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fPoint,fPoint,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fPoint,fPoint,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyRUSYAPixels[]={
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};




	///////////////////////////////////////////
	//  
	///////////////////////////////////////////


	static GLfloat *abyRUSaPixels=abyaPixels;
	static GLfloat abyRUSbPixels[]={
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyRUSvPixels[]={
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyRUSgPixels[]={
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyRUSdPixels[]={
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fSpace,
		fSpace,fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fSpace,
		fSpace,fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fSpace,
		fSpace,fSpace,fSpace,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};

	static GLfloat *abyRUSePixels=abyePixels;
	static GLfloat abyRUSyoPixels[]={
	fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fSpace,
	};
	static GLfloat abyRUSjPixels[]={
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fPoint,fSpace,
		fSpace,fSpace,fPoint,fSpace,fPoint,fPoint,fSpace,fSpace,
		fSpace,fSpace,fSpace,fPoint,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fPoint,fSpace,fPoint,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyRUSzPixels[]={
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyRUSiPixels[]={
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fPoint,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fPoint,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyRUSiyPixels[]={
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fPoint,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fPoint,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fPoint,fPoint,fSpace,fSpace,fSpace,
	};
	static GLfloat *abyRUSkPixels=abykPixels;
	static GLfloat abyRUSlPixels[]={
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fPoint,fPoint,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyRUSmPixels[]={
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fPoint,fPoint,fSpace,fPoint,fSpace,
		fSpace,fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyRUSnPixels[]={
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat *abyRUSoPixels=abyoPixels;
	static GLfloat abyRUSpPixels[]={
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat *abyRUSrPixels=abypPixels;
	static GLfloat *abyRUSsPixels=abycPixels;
	static GLfloat abyRUStPixels[]={
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyRUSuPixels[]={
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyRUSfPixels[]={
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fPoint,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat *abyRUShPixels=abyxPixels;
	static GLfloat abyRUScPixels[]={
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fPoint,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyRUSchPixels[]={
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyRUSshPixels[]={
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};

	static GLfloat abyRUSshjPixels[]={
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fPoint,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,
		fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyRUStvznPixels[]={
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fPoint,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyRUSbiPixels[]={
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fPoint,fPoint,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fPoint,fSpace,
		fSpace,fPoint,fPoint,fPoint,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyRUSmznPixels[]={
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyRUSe2Pixels[]={
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyRUSyuPixels[]={
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fPoint,fPoint,fSpace,fSpace,
		fSpace,fPoint,fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fPoint,fPoint,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fPoint,fPoint,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};
	static GLfloat abyRUSyaPixels[]={
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
	};

	static GLfloat abyPointPixels[]={
		//.
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fPoint,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fPoint,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		};
	static GLfloat abyCommaPixels[]={
		//.
		fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fPoint,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fPoint,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		};
	static GLfloat abySemicolonPixels[]={
		//.
		fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fPoint,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fPoint,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fPoint,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fPoint,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		};
	static GLfloat abyColonPixels[]={
		//.
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fPoint,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fPoint,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fPoint,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fPoint,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		};

	static GLfloat abyDashPixels[]={
		//.
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		};

	static GLfloat abyApostrophePixels[]={
		//.
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fPoint,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fPoint,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		};

	static GLfloat abyLessPixels[]={
		//.
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		};
	static GLfloat abyGreaterPixels[]={
		//.
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fPoint,fPoint,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		};
	static GLfloat abyEqualPixels[]={
		//.
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		};

	///////////////////////////////////////////
	//
	///////////////////////////////////////////
	static GLfloat abyZeroPixels[]={
		//Space bar
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fPoint,fPoint,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fPoint,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fPoint,fPoint,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		};
	static GLfloat abyOnePixels[]={
		//Space bar
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fPoint,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		};
	static GLfloat abyTwoPixels[]={
		//Space bar
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		};
	static GLfloat abyThreePixels[]={
		//Space bar
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		};
	static GLfloat abyFourPixels[]={
		//Space bar
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		};
	static GLfloat abyFivePixels[]={
		//Space bar
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		};
	static GLfloat abySixPixels[]={
		//Space bar
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		};
	static GLfloat abySevenPixels[]={
		//Space bar
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		};
	static GLfloat abyEightPixels[]={
		//Space bar
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		};
	static GLfloat abyNinePixels[]={
		//Space bar
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		};
	static GLfloat abySpacePixels[]={
		//Space bar
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		};

	static GLfloat abyPlusPixels[]={
		//Space bar
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		};
	static GLfloat abyMultiplyPixels[]={
		//Space bar
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fPoint,fSpace,fPoint,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fSpace,fPoint,fPoint,fPoint,fPoint,fPoint,fSpace,
		fSpace,fSpace,fSpace,fPoint,fPoint,fPoint,fSpace,fSpace,
		fSpace,fSpace,fPoint,fSpace,fPoint,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		};
	static GLfloat abyDividerPixels[]={
		//Space bar
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fPoint,fSpace,
		fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,fSpace,
		};

	for (n=CHAR_MIN;n<=CHAR_MAX;n++)
		m_pLetters[n]=abySpacePixels;

	m_pLetters['A']=abyAPixels;
	m_pLetters['B']=abyBPixels;
	m_pLetters['C']=abyCPixels;
	m_pLetters['D']=abyDPixels;
	m_pLetters['E']=abyEPixels;
	m_pLetters['F']=abyFPixels;
	m_pLetters['G']=abyGPixels;
	m_pLetters['H']=abyHPixels;
	m_pLetters['I']=abyIPixels;
	m_pLetters['J']=abyJPixels;
	m_pLetters['K']=abyKPixels;
	m_pLetters['L']=abyLPixels;
	m_pLetters['M']=abyMPixels;
	m_pLetters['N']=abyNPixels;
	m_pLetters['O']=abyOPixels;
	m_pLetters['P']=abyPPixels;
	m_pLetters['Q']=abyQPixels;
	m_pLetters['R']=abyRPixels;
	m_pLetters['S']=abySPixels;
	m_pLetters['T']=abyTPixels;
	m_pLetters['U']=abyUPixels;
	m_pLetters['V']=abyVPixels;
	m_pLetters['W']=abyWPixels;
	m_pLetters['X']=abyXPixels;
	m_pLetters['Y']=abyYPixels;
	m_pLetters['Z']=abyZPixels;

	m_pLetters['a']=abyaPixels;
	m_pLetters['b']=abybPixels;
	m_pLetters['c']=abycPixels;
	m_pLetters['d']=abydPixels;
	m_pLetters['e']=abyePixels;
	m_pLetters['f']=abyfPixels;
	m_pLetters['g']=abygPixels;
	m_pLetters['h']=abyhPixels;
	m_pLetters['i']=abyiPixels;
	m_pLetters['j']=abyjPixels;
	m_pLetters['k']=abykPixels;
	m_pLetters['l']=abylPixels;
	m_pLetters['m']=abymPixels;
	m_pLetters['n']=abynPixels;
	m_pLetters['o']=abyoPixels;
	m_pLetters['p']=abypPixels;
	m_pLetters['q']=abyqPixels;
	m_pLetters['r']=abyrPixels;
	m_pLetters['s']=abysPixels;
	m_pLetters['t']=abytPixels;
	m_pLetters['u']=abyuPixels;
	m_pLetters['v']=abyvPixels;
	m_pLetters['w']=abywPixels;
	m_pLetters['x']=abyxPixels;
	m_pLetters['y']=abyyPixels;
	m_pLetters['z']=abyzPixels;
	m_pLetters[' ']=abySpacePixels;


	//Russian
	m_pLetters['']=abyRUSAPixels;
	m_pLetters['']=abyRUSBPixels;
	m_pLetters['']=abyRUSVPixels;
	m_pLetters['']=abyRUSGPixels;
	m_pLetters['']=abyRUSDPixels;
	m_pLetters['']=abyRUSEPixels;
	m_pLetters['']=abyRUSYOPixels;
	m_pLetters['']=abyRUSJPixels;
	m_pLetters['']=abyRUSZPixels;
	m_pLetters['']=abyRUSIPixels;
	m_pLetters['']=abyRUSIYPixels;
	m_pLetters['']=abyRUSKPixels;
	m_pLetters['']=abyRUSLPixels;
	m_pLetters['']=abyRUSMPixels;
	m_pLetters['']=abyRUSNPixels;
	m_pLetters['']=abyRUSOPixels;
	m_pLetters['']=abyRUSPPixels;
	m_pLetters['']=abyRUSRPixels;
	m_pLetters['']=abyRUSSPixels;
	m_pLetters['']=abyRUSTPixels;
	m_pLetters['']=abyRUSUPixels;
	m_pLetters['']=abyRUSFPixels;
	m_pLetters['']=abyRUSHPixels;
	m_pLetters['']=abyRUSCPixels;
	m_pLetters['']=abyRUSCHPixels;
	m_pLetters['']=abyRUSSHPixels;
	m_pLetters['']=abyRUSSHJPixels;
	m_pLetters['']=abyRUSTVZNPixels;
	m_pLetters['']=abyRUSbIPixels;
	m_pLetters['']=abyRUSMZNPixels;
	m_pLetters['']=abyRUSE2Pixels;
	m_pLetters['']=abyRUSYUPixels;
	m_pLetters['']=abyRUSYAPixels;


	//Russian
	m_pLetters['']=abyRUSaPixels;
	m_pLetters['']=abyRUSbPixels;
	m_pLetters['']=abyRUSvPixels;
	m_pLetters['']=abyRUSgPixels;
	m_pLetters['']=abyRUSdPixels;
	m_pLetters['']=abyRUSePixels;
	m_pLetters['']=abyRUSyoPixels;
	m_pLetters['']=abyRUSjPixels;
	m_pLetters['']=abyRUSzPixels;
	m_pLetters['']=abyRUSiPixels;
	m_pLetters['']=abyRUSiyPixels;
	m_pLetters['']=abyRUSkPixels;
	m_pLetters['']=abyRUSlPixels;
	m_pLetters['']=abyRUSmPixels;
	m_pLetters['']=abyRUSnPixels;
	m_pLetters['']=abyRUSoPixels;
	m_pLetters['']=abyRUSpPixels;
	m_pLetters['']=abyRUSrPixels;
	m_pLetters['']=abyRUSsPixels;
	m_pLetters['']=abyRUStPixels;
	m_pLetters['']=abyRUSuPixels;
	m_pLetters['']=abyRUSfPixels;
	m_pLetters['']=abyRUShPixels;
	m_pLetters['']=abyRUScPixels;
	m_pLetters['']=abyRUSchPixels;
	m_pLetters['']=abyRUSshPixels;
	m_pLetters['']=abyRUSshjPixels;
	m_pLetters['']=abyRUStvznPixels;
	m_pLetters['']=abyRUSbiPixels;
	m_pLetters['']=abyRUSmznPixels;
	m_pLetters['']=abyRUSe2Pixels;
	m_pLetters['']=abyRUSyuPixels;
	m_pLetters['']=abyRUSyaPixels;

	// 
	m_pLetters['.']=abyPointPixels;
	m_pLetters[',']=abyCommaPixels;
	m_pLetters[';']=abySemicolonPixels;
	m_pLetters[':']=abyColonPixels;
	m_pLetters['-']=abyDashPixels;
	m_pLetters['`']=abyApostrophePixels;
	m_pLetters['<']=abyLessPixels;
	m_pLetters['>']=abyGreaterPixels;
	m_pLetters['=']=abyEqualPixels;

	m_pLetters['+']=abyPlusPixels;
	m_pLetters['*']=abyMultiplyPixels;
	m_pLetters['/']=abyDividerPixels;

	//
	m_pLetters['0']=abyZeroPixels;
	m_pLetters['1']=abyOnePixels;
	m_pLetters['2']=abyTwoPixels;
	m_pLetters['3']=abyThreePixels;
	m_pLetters['4']=abyFourPixels;
	m_pLetters['5']=abyFivePixels;
	m_pLetters['6']=abySixPixels;
	m_pLetters['7']=abySevenPixels;
	m_pLetters['8']=abyEightPixels;
	m_pLetters['9']=abyNinePixels;
}


void  CGL::MainLoop(void)
{
	glutMainLoop();
}

void CGL::OnIdle()
{
	glutPostRedisplay();
}

void CGL::InitOpenGL(char * WindowTitle, int *argc,char *argv[])
{
	glutInit(argc,argv);
	glutInitDisplayMode(GLUT_MULTISAMPLE| GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH |GLUT_STENCIL);

	glEnable(GLUT_MULTISAMPLE);
	glutCreateWindow(WindowTitle);
	glutDisplayFunc(Render);
	glutReshapeFunc(OnResize);
	glutSpecialFunc(OnSpecialKey);
	//glutIdleFunc(OnIdle);
	glutKeyboardFunc(OnKeyboard);
	glutTimerFunc(m_nTimerDelay,OnTimer,0);
	glutMouseFunc(OnMouse);
	glutPassiveMotionFunc(OnMouseMove);
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_LIGHTING);
	glEnableClientState(GL_COLOR_ARRAY);
	glEnableClientState(GL_VERTEX_ARRAY);
	glEnableClientState(GL_NORMAL_ARRAY);
	glEnable(GL_CULL_FACE);
	glEnable(GL_COLOR_MATERIAL);
	//glPolygonMode(GL_FRONT,GL_LINE);
	InitFont();
}

void CGL::WindowPosToGLPos(int p_nx, int p_ny, float * p_fx, float * p_fy)
{
    if (!p_fx) throw 1;
    if (!p_fy) throw 1;

    GLint ncx=m_siWidth/2,ncy=m_siHeight/2;// 
	GLint nDivider=(ncx<ncy?ncx:ncy);
	*p_fx=(GLfloat)(p_nx-ncx)/(GLfloat)nDivider;
	*p_fy=-(GLfloat)(p_ny-ncy)/(GLfloat)nDivider;
}
